#!BPY 

""" 
Name: 'ph_VertexMapper' 
Blender: 232 
Group: 'Misc' 
Tooltip: 'Simule une illumination globale sur le mesh via les vertexColor (Sans projection d ombre).' 
""" 

#--------------------------------------------
#      Ph_VertexMapper.py
#
#      Cree le 16/03/2004
#
#  par coolphil@worldonline.fr
#
#  Derniere modification: 21/04/2004
#
#--------------------------------------------

import Blender
from Blender import Scene, NMesh, Object
from Blender.Draw import *
from Blender.BGL import *
try:
	import meshtools
except:
	pass
import random
from random import *


##### Fx, Fy, Fz donnent la direction de la lumiere emettrice (de 0 a 1) ####
Fx = Create(0.00)
Fy = Create(0.00)
Fz = Create(0.80)

##### Fr, Fg, Fb sont les facteurs rgb qui donnent la couleur (de 0 a 1) ####
Fr = Create(0.80)
Fg = Create(0.80)
Fb = Create(0.80)

##### 'AmbLum' regle la luminosite ambiante (de 0.00 a 1.00) #####
AmbLum = Create(.50)

##### 'Emit' regle le type (ou la chaleur) de lumiere emettrice (valeur faible = lumiere ambiante,
#####  valeur eleve pour lumieres incandescente) (de 30 a 500) ####
Emit = Create(128)

##### 'Valnoise' rajoute un effet de 'bruit' #####
Valnoise = Create(0.00)

beep = Create(0)
beepText = "Off"

TitrPosY = 271 + 75

SlPosDirX = 30
SlPosDirY = 190 + 65

PosUpX = 165
PosUpY = 220 + 65
PosRightX = 165
PosRightY = 188 + 65

PosColX = 165
PosColY = 120 + 40

SlPosColX = 30
SlPosColY = 120 + 40

SlPosAmbX = 30
SlPosAmbY = 90 + 40

SlPosEmitX = 30
SlPosEmitY = 60 + 40

SlPosNoisY = 60

EVENT_EXIT = 1
EVENT_VMAP = 2
EVENT_REGLAGES = 3
EVENT_BEEP = 4

###############
def info_Obj(Ob):
###############

#	Ob = []
	obtype = 0
	mename = []
	me = []
	calque = 1

#	Ob = Object.GetSelected()[0]

	if Ob:
		if (Ob.getType() == 'Mesh'):
			obtype = 1
			calque = Ob.Layer                    # Le "layer" de l'object selectionne
			mename = Ob.getData().name
			me = Ob.getData()
	else:
		return [],[],[],[]

	return Ob, me, mename, calque, obtype

###########
def main():
###########
	global Fx, Fy, Fz, Fr, Fg, Fb, AmbLum, Emit, beep, beepText, Valnoise
	global EVENT_EXIT, EVENT_VMAP, EVENT_REGLAGES

	OBjets = Object.GetSelected()
	print Object.GetSelected()
	if OBjets:
		for o in OBjets:

			print "Object ",o
			Obj, mesh, meshname, layer, Obtype = info_Obj(o)

			if Obtype:
				print "Working on ",Obj.name
				if (not mesh.hasFaceUV()) and (not mesh.hasVertexColours()):
					print "L'objet %s n'a pas de 'TexFaces' ni de 'VertColor'." %o.name
					print "Je les construit ..."
					mesh.hasFaceUV(1)
					mesh.hasVertexColours(1)
					for f in mesh.faces:
						tp = []
						#print f.uv
						if len(f.v) == 4:
							tp1 = (0.0, 0.0)
							tp2 = (0.0, 1.0)
							tp3 = (1.0, 1.0)
							tp4 = (1.0, 0.0)
							tp.append(tp1)
							tp.append(tp2)
							tp.append(tp3)
							tp.append(tp4)
							#print tp
						elif len(f.v) == 3:
							tp1 = (0.0, 0.0)
							tp2 = (0.0, 1.0)
							tp3 = (1.0, 0.0)
							tp.append(tp1)
							tp.append(tp2)
							tp.append(tp3)
							#print tp
						f.uv = tp
						f.flag = 1

						for v in f.v:
							f.col.append(NMesh.Col(255, 255, 255, 255))

					NMesh.PutRaw(mesh, meshname)

				######## Pas sur que les 6 lignes suivantes soit nescessaire mais bon je les laisse au cas ou ... ######
				if not mesh.hasVertexColours(): #### Si pas de vertexColor: creation des Vcol ####
					print "Pas de VertColor ..."
					for f in mesh.faces:
						for v in f.v:
							f.col.append(NMesh.Col(255, 255, 255, 255))
					NMesh.PutRaw(mesh, meshname)

				if Valnoise.val:
#					print "Calculating noise ..."
					ListNoise = {}
					for v in mesh.verts:

						rnd = 1.0 - (0.1 * random() * Valnoise.val)
						ListNoise[v] = rnd

					for f in mesh.faces:
						for v in f.v:

							Rand = ListNoise[v]
							ConstVal = ((AmbLum.val+v.no[0]*Fx.val)+(AmbLum.val+v.no[1]*Fy.val)+(AmbLum.val+v.no[2]*Fz.val))*Emit.val*Rand

							f.col[f.v.index(v)].r=int(ConstVal*Fr.val)
							f.col[f.v.index(v)].g=int(ConstVal*Fg.val)
							f.col[f.v.index(v)].b=int(ConstVal*Fb.val)

				else:
					for f in mesh.faces:
						for v in f.v:

							ConstVal = ((AmbLum.val+v.no[0]*Fx.val)+(AmbLum.val+v.no[1]*Fy.val)+(AmbLum.val+v.no[2]*Fz.val))*Emit.val

							f.col[f.v.index(v)].r=int(ConstVal*Fr.val)
							f.col[f.v.index(v)].g=int(ConstVal*Fg.val)
							f.col[f.v.index(v)].b=int(ConstVal*Fb.val)


				NMesh.PutRaw(mesh, meshname)
				mesh = Obj.getData()
				mesh.update()
				Obj.makeDisplayList()
				print Obj.name, " finished !"; print

				Blender.Redraw()
			else:
				print "Skipped !";print

######### BEEP On / Off #######
		if beep.val:
			try:
				meshtools.print_boxed("Completed !"); print
			except:
				print "Completed !\a\r"
		else:
			print "Completed !"; print

##################
def draw():
##################
	global Fx, Fy, Fz, Fr, Fg, Fb, AmbLum, Emit, beep, beepText, Valnoise
	global PosUpX, PosUpY, PosRigthX, PosRigthY, PosColX, PosColY
	global EVENT_EXIT, EVENT_VMAP, EVENT_REGLAGES

	glClearColor(0.265, 0.41, 0.4, 1)
	glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)

	glColor3f(0,0,0)
	glRasterPos2d(31, TitrPosY + 1)
	Text("Ph_VertexMapper.py.")
	glRasterPos2d(32, TitrPosY)
	Text("Ph_VertexMapper.py.")
	glColor3f(1.,1.,1.)
	glRasterPos2d(30, TitrPosY + 2)
	Text("Ph_VertexMapper.py.")

	Button("Exit", EVENT_EXIT, 165, TitrPosY, 35, 20, "Quit.")


	################### Direction Button #########################

	glColor3f(0.4,0.3,0.2)
	glRecti(SlPosDirX - 5, SlPosDirY - 6, SlPosDirX + 170, SlPosDirY + 80)
	glColor3f(1,1,1)
	glRasterPos2d(30, SlPosDirY + 65)
	Text("Position :")

	glColor3f(1,0,0)
	glRecti(SlPosDirX + 122, SlPosDirY +40, SlPosDirX + 125, SlPosDirY + 54)
	Fx = Slider("X ", EVENT_REGLAGES, SlPosDirX, SlPosDirY + 40, 120, 15, Fx.val, -1.00, 1.00, 0, "Position X de la source lumineuse.")
	glColor3f(0,1,0)
	glRecti(SlPosDirX + 122, SlPosDirY + 20, SlPosDirX + 125, SlPosDirY +34)
	Fy = Slider("Y ", EVENT_REGLAGES, SlPosDirX, SlPosDirY + 20, 120, 15, Fy.val, -1.00, 1.00, 0, "Position Y de la source lumineuse.")
	glColor3f(0,0,1)
	glRecti(SlPosDirX + 122, SlPosDirY, SlPosDirX + 125, SlPosDirY +14)
	Fz = Slider("Z ", EVENT_REGLAGES, SlPosDirX, SlPosDirY, 120, 15, Fz.val, -1.00, 1.00, 0, "Position Z de la source lumineuse.")

	glColor3f(0,0,0)
	glRecti(PosUpX - 1, PosUpY - 1, PosUpX + 26, PosUpY + 26)
	glColor3f(0.45,0.45,0.45)
	glRecti(PosUpX, PosUpY, PosUpX + 25, PosUpY + 25)
	glColor3f(1,0,0)
	glRecti(PosUpX, PosUpY + 12, PosUpX +25, PosUpY + 13)
	glColor3f(0,1,0)
	glRecti(PosUpX + 12, PosUpY, PosUpX + 13, PosUpY +25)

	glColor3f(1,1,1)
	glRectf(PosUpX + 11 + (12*Fx.val), PosUpY + 11 +(12*Fy.val), PosUpX + 14 +(12*Fx.val), PosUpY + 14 +(12*Fy.val))

	glColor3f(0,0,0)
	glRecti(PosRightX - 1, PosRightY - 1, PosRightX + 26, PosRightY + 26)
	glColor3f(0.45,0.45,0.45)
	glRecti(PosRightX, PosRightY, PosRightX + 25, PosRightY + 25)
	glColor3f(0,1,0)
	glRecti(PosRightX, PosRightY + 12, PosRightX +25, PosRightY + 13)
	glColor3f(0,0,1)
	glRecti(PosRightX + 12, PosRightY, PosRightX + 13, PosRightY +25)

	glColor3f(1,1,1)
	glRectf(PosRightX + 11 +(12*Fy.val), PosRightY + 11 +(12*Fz.val), PosRightX + 14 +(12*Fy.val), PosRightY + 14 +(12*Fz.val))

	################### Color Button ############################

	glColor3f(0.8,0.6,0.2)
	glRecti(SlPosEmitX - 5, SlPosEmitY - 6, SlPosEmitX + 170, SlPosEmitY + 140)
	glColor3f(1,1,1)
	glRasterPos2d(30, SlPosColY + 65)
	Text("Couleur :")

	Fr = Slider("R ", EVENT_REGLAGES, SlPosColX, SlPosColY + 40, 120, 15, Fr.val, 0.00, 1.00, 0, "Couleur R")
	Fg = Slider("G ", EVENT_REGLAGES, SlPosColX, SlPosColY + 20, 120, 15, Fg.val, 0.00, 1.00, 0, "Couleur G")
	Fb = Slider("B ", EVENT_REGLAGES, SlPosColX, SlPosColY, 120, 15, Fb.val, 0.00, 1.00, 0, "Couleur B")

	glColor3f(1,1,1)
	glRecti(PosColX - 1, PosColY - 1, PosColX + 26, PosColY + 56)
	glColor3f(Fr.val,Fg.val,Fb.val)
	glRecti(PosColX, PosColY , PosColX + 25, PosColY + 55)

	AmbLum = Slider("AmbLum ", EVENT_REGLAGES, SlPosAmbX, SlPosAmbY, 170, 15, AmbLum.val, 0.00, 1.00, 0, "Intensite lumiere Ambiante.")

	Emit = Slider("Emit ", EVENT_REGLAGES, SlPosEmitX, SlPosEmitY, 170, 15, Emit.val, 30, 500, 0, "Intensite lumiere emettrice.")

	################## Noise Button ############################

	glColor3f(1,0.4,0.05)
	glRecti(SlPosEmitX - 5, SlPosNoisY - 6, SlPosEmitX + 170, SlPosNoisY + 20)

	Valnoise = Slider("Noise ", EVENT_REGLAGES, 30, SlPosNoisY, 170, 15, Valnoise.val, 0.00, 1.00, 0, "Amplitude du bruit (0 = Off).")

	############################################################

	Button("VMap", EVENT_VMAP, 30, 20, 60, 20, "Cree les vertex map sur les objects selectionnes.")

	glColor3f(0.5,0.5,0.5)
	glRecti(130, 20, 168,38)
	glColor3f(1.,1.,1.)
	glRasterPos2d(135, 27)
	Text("Beep:")
	beep = Toggle(beepText, EVENT_BEEP, 175, 20, 25, 20, beep.val, "Avertisseur sonore (On/Off).")

######################
######################
def event(evt, val): #
					 #
######################
	if ( evt == ESCKEY and not val):
		Exit()

	if (evt== QKEY and not val):
		Exit()



######################
######################
def bevent(evt):	 #
					 #
######################
	global Fx, Fy, Fz, Fr, Fg, Fb, AmbLum, Emit, beep, beepText
	global EVENT_EXIT, EVENT_VMAP, EVENT_REGLAGES

	if evt == EVENT_EXIT:
		Exit()

	if evt == EVENT_REGLAGES:
		Blender.Window.Redraw()

	if evt == EVENT_BEEP:
		if beep.val:
			beepText = "On"
		else:
			beepText = "Off"
		Blender.Window.Redraw()

	if evt == EVENT_VMAP:
		main()

	Blender.Window.Redraw()

######################
Register(draw, event, bevent)
######################